$(function() {
var markerPath = {
"Original Signal": "M 0 8 C 2 4 7 4 9.5 8 C 11 12 16 12 18 8 L 18 10 C 16 14 11 14 8.5 10 C 7 6 2 6 0 10 Z",
"Noisy Signal": "M 18 8 L 12 12 L 7 3 L 0 7.4 L 0 10 L 6 6 L 11 15 L 18 10.6 Z"
};
$("#chart").dxChart({
dataSource: dataSource,
title: "Noisy and Original Signals",
commonSeriesSettings: {
argumentField: "argument",
point: {
visible: false
}
},
series: [{
valueField: "originalValue",
name: "Original Signal"
}, {
valueField: "value",
name: "Noisy Signal"
}],
legend: {
verticalAlignment: "bottom",
horizontalAlignment: "center",
markerTemplate: function(item, group) {
var marker = document.createElementNS("http://www.w3.org/2000/svg", "path");
var background = document.createElementNS("http://www.w3.org/2000/svg", "rect");
var color = item.series.isVisible() ? item.marker.fill : "#888";
background.setAttribute("fill", color);
background.setAttribute("opacity", 0.3);
background.setAttribute("width", 18);
background.setAttribute("height", 18);
background.setAttribute("x", 0);
background.setAttribute("y", 0);
marker.setAttribute("fill", color);
marker.setAttribute("d", markerPath[item.series.name]);
group.appendChild(marker);
group.appendChild(background)
}
},
onLegendClick(e) {
e.target.isVisible() ? e.target.hide() : e.target.show();
}
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.6/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="chart"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}
function generateData(start, end, step) {
var data = [];
for (var i = start; i < end; i += step) {
var originalValue = Math.sin(i) / i;
data.push({ value: originalValue + ((0.5 - Math.random()) / 10), originalValue: originalValue, argument: i });
}
return data;
}
var dataSource = generateData(2.5, 12, 0.1);

<template>
<DxChart
id="chart"
:data-source="dataSource"
title="Noisy and Original Signals"
@legend-click="onLegendClick"
>
<DxCommonSeriesSettings
argument-field="argument"
>
<DxPoint :visible="false"/>
</DxCommonSeriesSettings>
<DxSeries
value-field="originalValue"
name="Original Signal"
/>
<DxSeries
value-field="value"
name="Noisy Signal"
/>
<DxLegend
vertical-alignment="bottom"
horizontal-alignment="center"
marker-template="markerTemplate"
/>
<template #markerTemplate="{ data }">
<MarkerTemplate :item="data"/>
</template>
</DxChart>
</template>
<script>
import {
DxChart, DxSeries, DxCommonSeriesSettings, DxPoint, DxLegend,
} from 'devextreme-vue/chart';
import { dataSource } from './data.js';
import MarkerTemplate from './MarkerTemplate.vue';
export default {
components: {
DxChart,
DxSeries,
DxCommonSeriesSettings,
DxPoint,
DxLegend,
MarkerTemplate,
},
data() {
return {
dataSource,
};
},
methods: {
onLegendClick(e) {
e.target.isVisible() ? e.target.hide() : e.target.show();
},
},
};
</script>
<style>
#chart {
height: 440px;
}
</style>
<template>
<svg>
<rect
:x="0"
:y="0"
:width="18"
:height="18"
:fill="color"
:opacity="0.3"
/>
<path
:d="d"
:fill="color"
/>
</svg>
</template>
<script>
const markerPath = {
'Original Signal': 'M 0 8 C 2 4 7 4 9.5 8 C 11 12 16 12 18 8 L 18 10 C 16 14 11 14 8.5 10 C 7 6 2 6 0 10 Z',
'Noisy Signal': 'M 18 8 L 12 12 L 7 3 L 0 7.4 L 0 10 L 6 6 L 11 15 L 18 10.6 Z',
};
export default {
props: {
item: {
type: Object,
default: () => {},
},
},
data() {
return {
color: this.item.series.isVisible() ? this.item.marker.fill : '#888',
d: markerPath[this.item.series.name],
};
},
};
</script>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
function generateData(start, end, step) {
const data = [];
for (let i = start; i < end; i += step) {
const originalValue = Math.sin(i) / i;
data.push({ value: originalValue + ((0.5 - Math.random()) / 10), originalValue, argument: i });
}
return data;
}
export const dataSource = generateData(2.5, 12, 0.1);
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.3/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.1.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.57/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.30/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

import React from 'react';
import {
Chart, Series, CommonSeriesSettings, Point, Legend,
} from 'devextreme-react/chart';
import { dataSource } from './data.js';
import markerTemplate from './MarkerTemplate.js';
class App extends React.Component {
onLegendClick(e) {
e.target.isVisible() ? e.target.hide() : e.target.show();
}
render() {
return (
<Chart id="chart"
title="Noisy and Original Signals"
dataSource={dataSource}
onLegendClick={this.onLegendClick}>
<CommonSeriesSettings
argumentField="argument">
<Point visible={false}></Point>
</CommonSeriesSettings>
<Series
valueField="originalValue"
name="Original Signal"
/>
<Series
valueField="value"
name="Noisy Signal"
/>
<Legend
verticalAlignment="bottom"
horizontalAlignment="center"
markerRender={markerTemplate}
>
</Legend>
</Chart>
);
}
}
export default App;
import React from 'react';
const markerPath = {
'Original Signal': 'M 0 8 C 2 4 7 4 9.5 8 C 11 12 16 12 18 8 L 18 10 C 16 14 11 14 8.5 10 C 7 6 2 6 0 10 Z',
'Noisy Signal': 'M 18 8 L 12 12 L 7 3 L 0 7.4 L 0 10 L 6 6 L 11 15 L 18 10.6 Z',
};
export default function MarkerTemplate(item) {
const color = item.series.isVisible() ? item.marker.fill : '#888';
return (
<svg>
<rect x={0} y={0} width={18} height={18} fill={color} opacity={0.3}></rect>
<path d={markerPath[item.series.name]} fill={color}></path>
</svg>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}
function generateData(start, end, step) {
const data = [];
for (let i = start; i < end; i += step) {
const originalValue = Math.sin(i) / i;
data.push({ value: originalValue + ((0.5 - Math.random()) / 10), originalValue, argument: i });
}
return data;
}
export const dataSource = generateData(2.5, 12, 0.1);
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@21.2.7/cjs',
'devextreme-react': 'npm:devextreme-react@21.2.7',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.14/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.47/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.0.13/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@2.3.14',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@2.3.14/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<dx-chart
id='chart'
[dataSource]="dataSource"
(onLegendClick)="onLegendClick($event)"
>
<dxo-title
text='Noisy and Original Signals'>
</dxo-title>
<dxo-common-series-settings
argumentField="argument">
<dxo-point [visible]='false'></dxo-point>
</dxo-common-series-settings>
<dxi-series
valueField='originalValue'
name='Original Signal'>
</dxi-series>
<dxi-series
valueField='value'
name='Noisy Signal'>
</dxi-series>
<dxo-legend
verticalAlignment='bottom'
horizontalAlignment='center'
markerTemplate="markerTemplate">
<svg *dxTemplate="let item of 'markerTemplate'" attr.fill="{{getMarkerColor(item)}}">
<rect x="0" y="0" width="18" height="18" opacity="0.3" attr.fill="getMarkerColor(item)"></rect>
<path attr.d="{{getMarkerPath(item.series.name)}}"></path>
</svg>
</dxo-legend>
</dx-chart>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxChartModule } from 'devextreme-angular';
import { Data, Service } from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service]
})
// const markerPath =
export class AppComponent {
dataSource: Data[];
markerPath: any;
constructor(service: Service) {
this.dataSource = service.getData();
this.markerPath = {
"Original Signal": "M 0 8 C 2 4 7 4 9.5 8 C 11 12 16 12 18 8 L 18 10 C 16 14 11 14 8.5 10 C 7 6 2 6 0 10 Z",
"Noisy Signal": "M 18 8 L 12 12 L 7 3 L 0 7.4 L 0 10 L 6 6 L 11 15 L 18 10.6 Z"
};
}
getMarkerPath(name) {
return this.markerPath[name];
}
getMarkerColor(item) {
return item.series.isVisible() ? item.marker.fill : "#888";
}
onLegendClick(e) {
e.target.isVisible() ? e.target.hide() : e.target.show();
}
}
@NgModule({
imports: [
BrowserModule,
DxChartModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #chart {
height: 440px;
}
import { Injectable } from '@angular/core';
export class Data {
value: number;
originalValue: number;
argument: number
}
function generateData(start:number, end:number, step:number) {
const data:Data[] = [];
for (let i = start; i < end; i += step) {
const originalValue = Math.sin(i) / i;
data.push({ value: originalValue + ((0.5 - Math.random()) / 10), originalValue: originalValue, argument: i });
}
return data;
}
@Injectable()
export class Service {
getData(): Data[] {
return generateData(2.5, 12, 0.1);;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.1.0/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.5',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.11',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.18',
'devextreme-angular': 'npm:devextreme-angular@20.2.5',
'preact': 'npm:preact@10.5.11/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.11/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>